#include "cmp_demo.h"
#include "isr.h"
volatile uint32_t g_Cmp0IntTaken;
void Cmp0_Init()
{
	GPIO_InitTypeDef GPIO_InitStruct ={0};
	CMP_InitTypeDef CMP_InitStruct = {0};

	GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_0, GROUP_AF_ODEFAULT); //PA00ĬϹVC0_INP0
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
	GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_ANA;
	GPIO_Init(GPIO_PORTA,&GPIO_InitStruct);       //PA0 VCIN0 pin
	
	GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_11, GROUP_AF_VC0OUT); //PA11ĬϹVC0out
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_11;
	GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_DIG;
	GPIO_Init(GPIO_PORTA,&GPIO_InitStruct);     //PA11 output

	CMP_InitStruct.CMP_Channel = CMP_Channel_0;  //Ƚ0
	CMP_InitStruct.CMP_PositiveSide = CMPx_PositiveSide_VCIN0;//ѡȽź
	CMP_InitStruct.CMP_NegativeSide = CMPx_NegativeSide_DAC;//DACΪ
	CMP_InitStruct.CMP_Int = CMP_Int_Enable;       //Ƚжʹ
	CMP_InitStruct.CMP_IntReq = CMP_IntReq_Both; //Ƚشж
	CMP_InitStruct.CMP_Filter = CMP_Filter_Fclk8;  //Ƚ˲
	CMP_InitStruct.CMP_HyMode = CMP_HyMode_None;  //ûг
	CMP_InitStruct.CMP_Polarity = CMP_Out_Noraml;  //ת
	CMP_InitStruct.CMP_Out2port = CMP_Out_Enable;//cmp0ȽVCOUT0ʹ

    ISR_Register(CMP0_IRQn, cmp0_interrupt);     //жϷ·ע

	CMP_Init(&CMP_InitStruct);
}

void cmp0_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(CMP0_IRQn);     /* clear INTCMP1 interrupt flag */
	g_Cmp0IntTaken++;
}

void Cmp1_Init()
{
	GPIO_InitTypeDef GPIO_InitStruct ={0};
	CMP_InitTypeDef CMP_InitStruct = {0};

	GPIO_PinAFConfig(GPIO_PORTB, GPIO_Pin_11, GROUP_AF_ODEFAULT); //PB11ĬϹVC1_INP2
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_11;
	GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_ANA;
	GPIO_Init(GPIO_PORTB,&GPIO_InitStruct);       
	
	GPIO_PinAFConfig(GPIO_PORTA, GPIO_Pin_7, GROUP_AF_VC1OUT); //PA07ĬϹVC1out
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_7;
	GPIO_InitStruct.GPIO_Mode    = GPIO_Mode_OUT;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_DIG;
	GPIO_Init(GPIO_PORTA,&GPIO_InitStruct);     

	CMP_InitStruct.CMP_Channel = CMP_Channel_1;  //Ƚ1
	CMP_InitStruct.CMP_PositiveSide = CMPx_PositiveSide_VCIN2;//ѡȽź
	CMP_InitStruct.CMP_NegativeSide = CMPx_NegativeSide_BGR;//ڲ׼ѹ
	CMP_InitStruct.CMP_Int = CMP_Int_Enable;       //Ƚжʹ
	CMP_InitStruct.CMP_IntReq = CMP_IntReq_Falling; //Ƚشж
	CMP_InitStruct.CMP_Filter = CMP_Filter_None;  //Ƚ˲
	CMP_InitStruct.CMP_HyMode = CMP_HyMode_None;  //ûг
	CMP_InitStruct.CMP_Polarity = CMP_Out_Noraml;  //ת
	CMP_InitStruct.CMP_Out2port = CMP_Out_Enable;//cmp1ȽVCOUT1ʹ
	

	CMP_Init(&CMP_InitStruct);
    ISR_Register(CMP1_IRQn, cmp1_interrupt);     //жϷ·ע

}
void cmp1_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(CMP1_IRQn);     /* clear INTCMP1 interrupt flag */
}
