/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A6703
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tima_demo.h"
#include "delay_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
	uint32_t msCnt; 	// count value of 1ms
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
    delay_init(SystemCoreClock);
	
	led_Init();

	Uart0_Init(19200);

	/*16MƵʱΪ2Mʱ(1/2000000) *10000 =5ms*/
	TMA_IntervalTimer(TMA_FCLK_Div8, 10000);
    TMA_Start();
	while(1)
	{
		delayMS(1000);
		GPIO_ToggleBits(GPIO_PORTA,GPIO_Pin_2);
	}

}



