#ifndef __TIM_DEMO_H__
#define __TIM_DEMO_H__
#include "gpio.h"
#include "tima.h"
#include "isr.h"

void tima_interrupt(void *msg);
void tima_timerinterrupt(void *msg);

void TMA_SquareOutput(TMA_Clk_t clk, uint16_t num);
void TMA_IntervalTimer(TMA_Clk_t clk, uint16_t num);

void TMA_EventCount_Init(uint16_t tma_edge, uint16_t tma_ctrol,uint16_t num);
void TMA_Get_PulseWidth(uint16_t clk, TMA_Pulse_t level);
void TMA_Get_PulsePeriod(uint16_t clk, TMA_Pulse_t edge);




#endif
