/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32A6703
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tima_demo.h"
#include "delay_demo.h"

#define TMA_COUNT_UNDER_CTROL_CONDITION

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern  uint16_t g_tma0_underflow_count ;


int main()
{
	uint32_t msCnt,i; 	// count value of 1ms

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	GPIO_InitTypeDef GPIO_InitStruct={};	

	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	delay_init(SystemCoreClock);
	
	Uart0_Init(19200);

	/*ͨPA1ΣPB4ţPB4PA1ؽм,ֵﵽ10жϣg_tma0_underflow_countֵ1*/	
	Gpio_Init();
	/*Example3:Tim4 count external event, when 10 pulses are captured, g_Int_Taken will increase 1*/
	TMA_EventCount_Init(TMA_RISING_EDGE,TMA_COUNT_AWLAYS, 10);
	TMA_Start();
	while(1)
	{
		GPIO_SetBits(GPIO_PORTA,GPIO_Pin_1);
		delayMS(250);
		GPIO_ResetBits(GPIO_PORTA,GPIO_Pin_1);
		delayMS(250);
		printf("g_Int_Taken= %d\n", g_tma0_underflow_count);
	}	

}




